var RemoteConnectivity={	
		makePostCall:function(sUrl, queryString,sData, callback, authenticated) {
			try {
	            var handle = new WebserviceConnection();
	            if (this.isNewWebrequest()) {
	    		    lInfo.logln("making new post " + sUrl + ' queryString: ' + queryString + '&token=' + this.getOSPToken() +' with data ' + sData + ' authenticated ' + authenticated);
	    		    handle.request(sUrl,queryString, 'POST', {},
                            sData ,authenticated, function(code, retdata) {
    	                        if (code === 200) {
    	                            lInfo.logln( ': OK [' + code + ']');
    	                        } else {
    	                            lWarn.logln('making POST request ' + sUrl + ' queryString: ' + queryString + ' with data ' + sData +' : FAILED! Server replied: "' + code + '"');
    	                        }
    	                        lInfo.logln(': body [' + retdata + ']');
    	                        callback(JSON.parse(retdata));
                    });	            	
	            } else {
	    		    lInfo.logln("making post " + sUrl + ' with data ' + sData);
	    		    if (authenticated)
	    		    	queryString+='&token=' + this.getOSPToken();
		            handle.request(sUrl+'?'+queryString, 'POST', {},
		                            sData , function(code, retdata) {
	        	                        if (code === 200) {
	        	                            lInfo.logln( ': OK [' + code + ']');
	        	                        } else {
	        	                            lWarn.logln('making POST request ' + sUrl + '?' +queryString + ' with data ' + sData +': FAILED! Server replied: "' + code + '"');
	        	                        }
	        	                        lInfo.logln(': body [' + retdata + ']');
	        	                        callback(JSON.parse(retdata));
		                    });
	            }
			} catch (e) {
				lWarn.logln("Error during post call: ");
			    for (var i in e) {
			        lWarn.logln(i + ': ' + e[i]);
			    }
			}
		},
        makeCall:function(sUrl, queryString, callback, authenticated) {
            lInfo.logln("making get request " + sUrl);
            try {
                var handle = new WebserviceConnection(); 
                if (this.isNewWebrequest()) {
	                handle.simplerequest(sUrl,queryString, 'GET', authenticated ,function(code, retdata) {
	                    if (code === 200) {
	                        lInfo.logln( ': OK [' + code + ']');
	                    } else {
	                        lWarn.logln('making GET request ' + sUrl + '?' + queryString +' : FAILED! Server replied: "' + code + '"');
	                    }
	                    lInfo.logln(': body [' + retdata + ']');
	                    callback(JSON.parse(retdata));
	                });
                } else {
                	
	                handle.simplerequest(sUrl+'?' + queryString, 'GET', function(code, retdata) {
	                    if (code === 200) {
	                        lInfo.logln( ': OK [' + code + ']');
	                    } else {
	                        lWarn.logln('making GET request ' + sUrl + '?' + queryString +' : FAILED! Server replied: "' + code + '"');
	                    }
	                    lInfo.logln(': body [' + retdata + ']');
	                    callback(JSON.parse(retdata));
	                });
                }
            } catch (e) {
                lWarn.logln("Error during get call: ");
                for (var i in e) {
                    lWarn.logln(i + ': ' + e[i]);
                }
            }
        },
        isNewWebrequest:function() {
            return (Property.getNode('/scripts/system-addon-remote-connectivity') != null);
        },
        CheckUserByMAC:function(callback) {
			var sMac=this.getMyMac();
			this.makeCall("/internal/accessmanagement/v1_0/Account/CheckUserByMAC", "macaddress=" + sMac, callback,false);
		},
		CheckExistingConnection: function(username, password, callback) {
			var sDSID = this.getMyDSID();
			this.makeCall("/internal/accessmanagement/v1_0/RemoteConnectivity/IsRCRestorePossibleForUser", "User=" + username + "&Password=" + password + "&dssid=" + sDSID, callback,false);
		},
		CheckExistingTempdSConfiguratorLink : function(callback) {
		    var sParameters =  "dssid=" + this.getMyDSID() + "&type=Installer";
            this.makeCall("/internal/accessmanagement/v1_1/RemoteConnectivity/CheckExistingTempdSConfiguratorLink", sParameters, callback, true);
		},
        ActivatedSHubConnectivity : function(dSToken, callback) {
            var sParameters = 'dstoken=' + dSToken +  '&user=' + this.getUserName() + '&dssid=' + this.getMyDSID();
            lInfo.logln("call /internal/accessmanagement/v1_1/RemoteConnectivity/ActivatedSHubConnectivity?" + sParameters);
            this.makePostCall('/internal/accessmanagement/v1_1/RemoteConnectivity/ActivatedSHubConnectivity', sParameters, {}, callback, true);
        },
		getMyMac: function(){
			return Property.getProperty('/system/host/interfaces/eth0/mac');
		},
		getMyDSID:function(){
			return Property.getProperty('/system/dSID');			
		},
		getMyDSUID:function(){
			return Property.getProperty('/system/dSUID');			
		},
		getMySGTIN:function() {
			return Property.getProperty('/system/dSID');
		},
		getUserName:function(){
			return Property.getProperty('username');			
		},
        enableToken:function(TokenName) {
            var name=Property.getNode('/system/security/applicationTokens/pending/' + TokenName+'/applicationName').getValue();
            Property.setProperty('/system/security/applicationTokens/enabled/' + TokenName + "/token", TokenName);
            Property.setFlag('/system/security/applicationTokens/enabled/' + TokenName + "/token", 'ARCHIVE', true);
            Property.setProperty('/system/security/applicationTokens/enabled/' + TokenName + "/applicationName", name);
            Property.setFlag('/system/security/applicationTokens/enabled/' + TokenName + "/applicationName", 'ARCHIVE', true);
            Property.setProperty('/system/security/applicationTokens/enabled/' + TokenName + "/user", "dssadmin");
            Property.setFlag('/system/security/applicationTokens/enabled/' + TokenName + "/user", 'ARCHIVE', true);         
            Property.setProperty('/system/security/applicationTokens/enabled/' + TokenName + "/source", "remote-connectivity");
            Property.setFlag('/system/security/applicationTokens/enabled/' + TokenName + "/source", 'ARCHIVE', true);           
            Property.getNode('/system/security/applicationTokens/pending').removeChild(TokenName ); 
        },
		getOSPToken:function() {
			Property.load();
			var ospToken=Property.getNode('OSPToken');
			if (ospToken==null) {
                lWarn.logln("OSPToken property not found");
                return '';
			}
			return ospToken.getValue();
		},
		getDSToken:function() {
			Property.load();
			var dSToken=Property.getNode('dSToken');
			if (dSToken==null) {
                lWarn.logln("dSToken property not found");
                return '';
			}
			return dSToken.getValue();
		}
};